%bcond_without tests

Summary:        A command-line program to download videos from online video platforms
Name:           yt-dlp
Version:        2024.12.23
Release:        1%{?dist}

License:        Unlicense
URL:            https://github.com/%{name}/%{name}
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz
Source1:        yt-dlp.spec.license

BuildArch:      noarch

BuildRequires:  python3-devel

BuildRequires:  tomcli

%if %{with tests}
BuildRequires:  %{py3_dist pytest}
%endif

BuildRequires:  pandoc
BuildRequires:  make

Recommends:     /usr/bin/ffmpeg
Recommends:     /usr/bin/ffprobe

Suggests:       python3dist(keyring)

%global _description %{expand:
yt-dlp is a command-line program to download videos from many different online
video platforms, such as youtube.com. The project is a fork of youtube-dl with
additional features and fixes.}

%description %{_description}

%package bash-completion
Summary:        Bash completion for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       bash-completion
Supplements:    (%{name} and bash-completion)

%description bash-completion
Bash command line completion support for %{name}.

%package zsh-completion
Summary:        Zsh completion for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       zsh
Supplements:    (%{name} and zsh)

%description zsh-completion
Zsh command line completion support for %{name}.

%package fish-completion
Summary:        Fish completion for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       fish
Supplements:    (%{name} and fish)

%description fish-completion
Fish command line completion support for %{name}.

%prep
%autosetup

find -type f ! -executable -name '*.py' -print -exec sed -i -e '1{\@^#!.*@d}' '{}' +
tomcli-set pyproject.toml lists replace project.dependencies \
    '(requests|urllib3|websockets)>=.*' '\1'

%generate_buildrequires
%pyproject_buildrequires -r

%build
make yt-dlp.1 completion-bash completion-zsh completion-fish

%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files yt_dlp

%check
%if %{with tests}
%pytest -k "not download"
%endif

%files -f %{pyproject_files}
%{_bindir}/%{name}
%{_mandir}/man1/%{name}.1*
%doc README.md
%license LICENSE

%files bash-completion
%{bash_completions_dir}/%{name}

%files zsh-completion
%{zsh_completions_dir}/_%{name}

%files fish-completion
%{fish_completions_dir}/%{name}.fish

%changelog
* Thu Dec 26 2024 Sinong Chen <costinchen@tencent.com> - 2024.12.23-1
- [Type] security
- [DESC] Upgrade to yt-dlp-2024.12.23 to fix CVE-2024-22423

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2023.12.30-1
- initial build
